package br.com.portillodesign.ficharapida;

import android.app.Activity;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.net.http.AndroidHttpClient;
import android.nfc.NdefMessage;
import android.nfc.NdefRecord;
import android.nfc.NfcAdapter;
import android.nfc.Tag;
import android.nfc.tech.Ndef;
import android.nfc.tech.NdefFormatable;
import android.os.AsyncTask;
import android.os.Parcelable;
import android.os.StrictMode;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.util.Base64;
import android.util.Log;
import android.util.Pair;
import android.view.Menu;
import android.view.MenuItem;
import android.view.TextureView;
import android.view.View;
import android.widget.EditText;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ToggleButton;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.ResponseHandler;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.BasicResponseHandler;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.params.BasicHttpParams;
import org.json.JSONObject;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.ByteArrayOutputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Locale;

import javax.net.ssl.HttpsURLConnection;

import br.com.portillodesign.ficharapida.R;


public class MainActivity extends ActionBarActivity {

    NfcAdapter nfcAdapter;

    ToggleButton tglReadWrite;
    TextView txtTagContent;
    TextView txtNome;
    TextView txtIdade;
    TextView txtDelito;
    TextView txtUnidade;
    TextView txtPena;
    TextView txtCumprida;
    ImageView imgFoto;

    private static final int REQUEST_CODE = 1;
    private Bitmap bitmap;
    private ImageView imageView;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(br.com.portillodesign.ficharapida.R.layout.activity_main);

        StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll().build();
        StrictMode.setThreadPolicy(policy);

        nfcAdapter = NfcAdapter.getDefaultAdapter(this);
        tglReadWrite = (ToggleButton)findViewById(R.id.tglReadWrite);
        txtTagContent = (TextView)findViewById(R.id.txtTagContent);
        txtNome = (TextView)findViewById(R.id.Nome);
        txtIdade = (TextView)findViewById(R.id.Idade);
        txtDelito = (TextView)findViewById(R.id.Delito);
        txtUnidade = (TextView)findViewById(R.id.Unidade);
        txtPena = (TextView)findViewById(R.id.Pena);
        txtCumprida = (TextView)findViewById(R.id.Cumprida);
        imgFoto = (ImageView)findViewById(R.id.foto);

        Toast.makeText( getApplicationContext(), "Iniciando Sistema", Toast.LENGTH_LONG).show();


    }

    @Override
    protected void onResume() {
        super.onResume();

        enableForegroundDispatchSystem();
    }

    @Override
    protected void onPause() {
        super.onPause();

        disableForegroundDispatchSystem();
    }

    private String bytesToHexString(byte[] src) {
        StringBuilder stringBuilder = new StringBuilder("0x");
        if (src == null || src.length <= 0) {
            return null;
        }

        char[] buffer = new char[2];
        for (int i = 0; i < src.length; i++) {
            buffer[0] = Character.forDigit((src[i] >>> 4) & 0x0F, 16);
            buffer[1] = Character.forDigit(src[i] & 0x0F, 16);
            System.out.println(buffer);
            stringBuilder.append(buffer);
        }

        return stringBuilder.toString();
    }




    @Override
    protected void onNewIntent(Intent intent) {
        super.onNewIntent(intent);

        if (intent.hasExtra(NfcAdapter.EXTRA_TAG)) {
            //  Toast.makeText(this, "NfcIntent!", Toast.LENGTH_SHORT).show();

            if(tglReadWrite.isChecked())
            {
                Parcelable[] parcelables = intent.getParcelableArrayExtra(NfcAdapter.EXTRA_NDEF_MESSAGES);

                if(parcelables != null && parcelables.length > 0)
                {
                    readTextFromMessage((NdefMessage) parcelables[0]);
                }else{
                    Tag myTag = (Tag) intent.getParcelableExtra(NfcAdapter.EXTRA_TAG);
                    txtTagContent.setText(bytesToHexString(myTag.getId()));




                    //DAta e Hora
                   // DateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                    //get current date time with Date()
                   // Date date = new Date();
                    //get current date time with Calendar()
                   // Calendar cal = Calendar.getInstance();
                   // String dataHora = dateFormat.format(cal.getTime());

                    //Pegar foto e converter para Base64
                   /* View v = view.getRootView();
                    View z = (ImageView) findViewById(R.id.result);
                    z.setDrawingCacheEnabled(true);
                    Bitmap bitmap = Bitmap.createBitmap(z.getDrawingCache());*/

                    //  View z = (FrameLayout) findViewById(R.id.control);
                    // Bitmap bitmap;
                    // View v1 = z.getRootView();

                    //  View v1 = getWindow().getDecorView().getRootView();//this line for get better result

                    // z.setDrawingCacheEnabled(true);
                    // bitmap = Bitmap.createBitmap(z.getDrawingCache());
                    // z.setDrawingCacheEnabled(false);
                    /*View L1 = findViewById(R.id.picture);
                    View v1 = L1.getRootView();
                    v1.setDrawingCacheEnabled(true);
                    Bitmap bm = v1.getDrawingCache();*/
                 /*   View view = (ImageView) findViewById(R.id.result);
                    View v1 = view.getRootView();
                    Bitmap source = v1.getDrawingCache();
                    int x = v1.getWidth()/10;
                    int y = v1.getHeight()/10;
                    int width = source.getWidth() - x;
                    int height = source.getHeight() - y;
                    Bitmap bitmap = Bitmap.createBitmap(source, x, y, width, height);*/

                    //TextureView tv = (TextureView) findViewById(R.id.texture);
                    // Bitmap bitmap = Bitmap.createBitmap(imageView.getWidth(), imageView.getHeight(), Bitmap.Config.ARGB_8888);
                    /*Bitmap bitmap = tv.getBitmap();
                    ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();

                    int width = bitmap.getWidth();
                    int height = bitmap.getHeight();

                    float bitmapRatio = (float)width / (float) height;
                    if (bitmapRatio > 0) {
                        width = 500;
                        height = (int) (width / bitmapRatio);
                    } else {
                        height = 500;
                        width = (int) (height * bitmapRatio);
                    }

                    bitmap.compress(Bitmap.CompressFormat.JPEG, 70, byteArrayOutputStream);
                    bitmap = Bitmap.createScaledBitmap(bitmap, width, height, true);

                    byte[] byteArray = byteArrayOutputStream .toByteArray();

                    String encoded = Base64.encodeToString(byteArray, Base64.DEFAULT);
*/
                  /*  Toast.makeText(getApplicationContext(), "Seu código é: " + bytesToHexString(myTag.getId()), Toast.LENGTH_LONG).show();
                    Toast.makeText( getApplicationContext(), "Sua localização é: "+ local, Toast.LENGTH_LONG).show();
                    Toast.makeText( getApplicationContext(), "Hora: "+ dataHora, Toast.LENGTH_LONG).show();
                    Toast.makeText( getApplicationContext(), "Foto: "+ encoded, Toast.LENGTH_LONG).show();*/
                    // Toast.makeText(this, "No NDEF messages found!", Toast.LENGTH_SHORT).show();

                    //ENVIAR E GRAVAR DADOS


                  /*  HttpURLConnection conn = (HttpURLConnection) url.openConnection();
                        conn.setRequestMethod("POST");
                        conn.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
                        //conn.setRequestProperty("Set-Cookie", session);
                        //conn.setRequestProperty("Content-Length", "" + Integer.toString(postData.getBytes().length));
                        conn.setUseCaches(false);
                        conn.setDoInput(true);
                        conn.setDoOutput(true);*/
/*
                    List<Pair<String,String>> params = new ArrayList<Pair<String,String>>();
                    params.add(new Pair<>("nfc", bytesToHexString(myTag.getId())));
                    params.add(new Pair<>("data_envio", dataHora));
                    params.add(new Pair<>("latitude", latitude));
                    params.add(new Pair<>("longitude", longitude));
                    params.add(new Pair<>("foto", encoded));
*/

                  /*  byte[] outputInBytes = para.getBytes("UTF-8");
                    OutputStream os = conn.getOutputStream();
                    os.write( outputInBytes );
                    os.close();
                    conn.connect();*/

                    // TODO Auto-generatedmethod stub
                    // Create a new HttpClient and Post Header
                   // HttpClient httpclient = new DefaultHttpClient();
                   // HttpPost httppost = new HttpPost(url);
                    String urlDetentos = "http://portillodesign.com.br/pacto/dados/detentos.php?acao=4&id="+bytesToHexString(myTag.getId());

                    DefaultHttpClient   httpclient = new DefaultHttpClient(new BasicHttpParams());
                    HttpPost httppost = new HttpPost(urlDetentos);
// Depends on your web service
                    httppost.setHeader("Content-type", "application/json");

                    InputStream inputStream = null;
                    String result = null;
                    try {
                        HttpResponse response = httpclient.execute(httppost);
                        HttpEntity entity = response.getEntity();

                        inputStream = entity.getContent();
                        // json is UTF-8 by default
                        BufferedReader reader = new BufferedReader(new InputStreamReader(inputStream, "UTF-8"), 8);
                        StringBuilder sb = new StringBuilder();

                        String line = null;
                        while ((line = reader.readLine()) != null)
                        {
                            sb.append(line + "\n");
                        }
                        result = sb.toString();

                        JSONObject jObject = new JSONObject(result);

                        txtNome.setText(jObject.getString("nome"));
                        txtIdade.setText(jObject.getString("idade") + " anos");
                        txtDelito.setText(jObject.getString("delito"));
                        txtUnidade.setText(jObject.getString("unidade_prisional"));
                        txtPena.setText("Total da Pena: "+jObject.getString("total_pena") + " dias");
                        txtCumprida.setText("Pena Cumprida: "+jObject.getString("total_cumprido") + " dias");
                        String photo_url_str = "http://portillodesign.com.br/pacto/"+bytesToHexString(myTag.getId())+".jpg";
                        URL newurl = new URL(photo_url_str);
                        Bitmap mIcon_val = BitmapFactory.decodeStream(newurl.openConnection() .getInputStream());
                        imgFoto.setImageBitmap(mIcon_val);

                        Toast.makeText( getApplicationContext(), "DADOS CARREGADOS COM SUCESSO", Toast.LENGTH_LONG).show();

                    } catch (Exception e) {

                        Toast.makeText( getApplicationContext(), e.getMessage(), Toast.LENGTH_LONG).show();
                    }
                    finally {
                        try{if(inputStream != null)inputStream.close();}catch(Exception squish){}
                    }







              //      View v = (View) findViewById(R.id.raiz);;
                //    v.setBackgroundColor(Color.parseColor("#adde4e"));
                }




            }else{
                Tag tag = intent.getParcelableExtra(NfcAdapter.EXTRA_TAG);
                NdefMessage ndefMessage = createNdefMessage(txtTagContent.getText() + "");

                writeNdefMessage(tag, ndefMessage);
            }

        }
    }


    private void readTextFromMessage(NdefMessage ndefMessage) {

        NdefRecord[] ndefRecords = ndefMessage.getRecords();

        if(ndefRecords != null && ndefRecords.length>0){

            NdefRecord ndefRecord = ndefRecords[0];

            String tagContent = getTextFromNdefRecord(ndefRecord);

            txtTagContent.setText(tagContent);

        }else
        {
            Toast.makeText(this, "No NDEF records found!", Toast.LENGTH_SHORT).show();
        }

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(br.com.portillodesign.ficharapida.R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == br.com.portillodesign.ficharapida.R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }


    private void enableForegroundDispatchSystem() {

        Intent intent = new Intent(this, MainActivity.class).addFlags(Intent.FLAG_RECEIVER_REPLACE_PENDING);

        PendingIntent pendingIntent = PendingIntent.getActivity(this, 0, intent, 0);

        IntentFilter[] intentFilters = new IntentFilter[]{};

        nfcAdapter.enableForegroundDispatch(this, pendingIntent, intentFilters, null);
    }

    private void disableForegroundDispatchSystem() {
        nfcAdapter.disableForegroundDispatch(this);
    }

    private void formatTag(Tag tag, NdefMessage ndefMessage) {
        try {

            NdefFormatable ndefFormatable = NdefFormatable.get(tag);

            if (ndefFormatable == null) {
                Toast.makeText(this, "Tag is not ndef formatable!", Toast.LENGTH_SHORT).show();
                return;
            }


            ndefFormatable.connect();
            ndefFormatable.format(ndefMessage);
            ndefFormatable.close();

            Toast.makeText(this, "Tag writen!", Toast.LENGTH_SHORT).show();

        } catch (Exception e) {
            Log.e("formatTag", e.getMessage());
        }

    }

    private void writeNdefMessage(Tag tag, NdefMessage ndefMessage) {

        try {

            if (tag == null) {
                Toast.makeText(this, "Tag object cannot be null", Toast.LENGTH_SHORT).show();
                return;
            }

            Ndef ndef = Ndef.get(tag);

            if (ndef == null) {
                // format tag with the ndef format and writes the message.
                formatTag(tag, ndefMessage);
            } else {
                ndef.connect();

                if (!ndef.isWritable()) {
                    Toast.makeText(this, "Tag is not writable!", Toast.LENGTH_SHORT).show();

                    ndef.close();
                    return;
                }

                ndef.writeNdefMessage(ndefMessage);
                ndef.close();

                Toast.makeText(this, "Tag writen!", Toast.LENGTH_SHORT).show();

            }

        } catch (Exception e) {
            Log.e("writeNdefMessage", e.getMessage());
        }

    }


    private NdefRecord createTextRecord(String content) {
        try {
            byte[] language;
            language = Locale.getDefault().getLanguage().getBytes("UTF-8");

            final byte[] text = content.getBytes("UTF-8");
            final int languageSize = language.length;
            final int textLength = text.length;
            final ByteArrayOutputStream payload = new ByteArrayOutputStream(1 + languageSize + textLength);

            payload.write((byte) (languageSize & 0x1F));
            payload.write(language, 0, languageSize);
            payload.write(text, 0, textLength);

            return new NdefRecord(NdefRecord.TNF_WELL_KNOWN, NdefRecord.RTD_TEXT, new byte[0], payload.toByteArray());

        } catch (UnsupportedEncodingException e) {
            Log.e("createTextRecord", e.getMessage());
        }
        return null;
    }


    private NdefMessage createNdefMessage(String content) {

        NdefRecord ndefRecord = createTextRecord(content);

        NdefMessage ndefMessage = new NdefMessage(new NdefRecord[]{ndefRecord});

        return ndefMessage;
    }


    public void tglReadWriteOnClick(View view){
        txtTagContent.setText("");
    }


    public String getTextFromNdefRecord(NdefRecord ndefRecord)
    {
        String tagContent = null;
        try {
            byte[] payload = ndefRecord.getPayload();
            String textEncoding = ((payload[0] & 128) == 0) ? "UTF-8" : "UTF-16";
            int languageSize = payload[0] & 0063;
            tagContent = new String(payload, languageSize + 1,
                    payload.length - languageSize - 1, textEncoding);
        } catch (UnsupportedEncodingException e) {
            Log.e("getTextFromNdefRecord", e.getMessage(), e);
        }
        return tagContent;
    }

}
